]> git.lizzy.rs Git - rust.git/blob - src/ci/run.sh
add more debugging code to track down appveyor 259 exit code
[rust.git] / src / ci / run.sh
1 #!/usr/bin/env bash
2
3 set -e
4
5 if [ -n "$CI_JOB_NAME" ]; then
6   echo "[CI_JOB_NAME=$CI_JOB_NAME]"
7 fi
8
9 if [ "$NO_CHANGE_USER" = "" ]; then
10   if [ "$LOCAL_USER_ID" != "" ]; then
11     useradd --shell /bin/bash -u $LOCAL_USER_ID -o -c "" -m user
12     export HOME=/home/user
13     unset LOCAL_USER_ID
14     exec su --preserve-environment -c "env PATH=$PATH \"$0\"" user
15   fi
16 fi
17
18 # only enable core dump on Linux
19 if [ -f /proc/sys/kernel/core_pattern ]; then
20   ulimit -c unlimited
21 fi
22
23 ci_dir=`cd $(dirname $0) && pwd`
24 source "$ci_dir/shared.sh"
25
26 if [ "$TRAVIS" != "true" ] || [ "$TRAVIS_BRANCH" == "auto" ]; then
27     RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set build.print-step-timings --enable-verbose-tests"
28 fi
29
30 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-sccache"
31 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-manage-submodules"
32 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-locked-deps"
33 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-cargo-native-static"
34 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.codegen-units-std=1"
35
36 if [ "$DIST_SRC" = "" ]; then
37   RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-dist-src"
38 fi
39
40 # If we're deploying artifacts then we set the release channel, otherwise if
41 # we're not deploying then we want to be sure to enable all assertions because
42 # we'll be running tests
43 #
44 # FIXME: need a scheme for changing this `nightly` value to `beta` and `stable`
45 #        either automatically or manually.
46 export RUST_RELEASE_CHANNEL=nightly
47 if [ "$DEPLOY$DEPLOY_ALT" != "" ]; then
48   RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --release-channel=$RUST_RELEASE_CHANNEL"
49   RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-static-stdcpp"
50   RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.remap-debuginfo"
51
52   if [ "$NO_LLVM_ASSERTIONS" = "1" ]; then
53     RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-llvm-assertions"
54   elif [ "$DEPLOY_ALT" != "" ]; then
55     RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-assertions"
56     RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.verify-llvm-ir"
57   fi
58 else
59   # We almost always want debug assertions enabled, but sometimes this takes too
60   # long for too little benefit, so we just turn them off.
61   if [ "$NO_DEBUG_ASSERTIONS" = "" ]; then
62     RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-debug-assertions"
63   fi
64
65   # In general we always want to run tests with LLVM assertions enabled, but not
66   # all platforms currently support that, so we have an option to disable.
67   if [ "$NO_LLVM_ASSERTIONS" = "" ]; then
68     RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-assertions"
69   fi
70
71   RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.verify-llvm-ir"
72 fi
73
74 if [ "$RUST_RELEASE_CHANNEL" = "nightly" ] || [ "$DIST_REQUIRE_ALL_TOOLS" = "" ]; then
75     RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-missing-tools"
76 fi
77
78 # We've had problems in the past of shell scripts leaking fds into the sccache
79 # server (#48192) which causes Cargo to erroneously think that a build script
80 # hasn't finished yet. Try to solve that problem by starting a very long-lived
81 # sccache server at the start of the build, but no need to worry if this fails.
82 SCCACHE_IDLE_TIMEOUT=10800 sccache --start-server || true
83
84 if [ "$RUN_CHECK_WITH_PARALLEL_QUERIES" != "" ]; then
85   $SRC/configure --enable-parallel-compiler
86   CARGO_INCREMENTAL=0 python2.7 ../x.py check
87   rm -f config.toml
88   rm -rf build
89 fi
90
91 travis_fold start configure
92 travis_time_start
93 $SRC/configure $RUST_CONFIGURE_ARGS
94 travis_fold end configure
95 travis_time_finish
96
97 travis_fold start make-prepare
98 travis_time_start
99 retry make prepare
100 travis_fold end make-prepare
101 travis_time_finish
102
103 travis_fold start check-bootstrap
104 travis_time_start
105 make check-bootstrap
106 travis_fold end check-bootstrap
107 travis_time_finish
108
109 # Display the CPU and memory information. This helps us know why the CI timing
110 # is fluctuating.
111 travis_fold start log-system-info
112 if [ "$TRAVIS_OS_NAME" = "osx" ]; then
113     system_profiler SPHardwareDataType || true
114     sysctl hw || true
115     ncpus=$(sysctl -n hw.ncpu)
116 else
117     cat /proc/cpuinfo || true
118     cat /proc/meminfo || true
119     ncpus=$(grep processor /proc/cpuinfo | wc -l)
120 fi
121 travis_fold end log-system-info
122
123 if [ ! -z "$SCRIPT" ]; then
124   # This `set +e` followed by capturing the return value is a temporary measure
125   # to help debug "error with exit 259" on AppVeyor temporarily, otherwise all
126   # that's needed here is the `sh`
127   set +e
128   sh -x -c "$SCRIPT"
129   ret=$?
130   echo "exit code in src/ci/run.sh: $ret"
131   exit $ret
132 else
133   do_make() {
134     travis_fold start "make-$1"
135     travis_time_start
136     echo "make -j $ncpus $1"
137     make -j $ncpus $1
138     local retval=$?
139     travis_fold end "make-$1"
140     travis_time_finish
141     return $retval
142   }
143
144   do_make tidy
145   do_make all
146   do_make "$RUST_CHECK_TARGET"
147 fi